﻿// See https://aka.ms/new-console-template for more information

using FluentValidation;
using Hello_Mediatr.Behaviours;
using Hello_Mediatr.Domain.Entities;
using Hello_Mediatr.Domain.Enums;
using Hello_Mediatr.Mediatr.Commands;
using Hello_Mediatr.Mediatr.Requests;
using Hello_Mediatr.Store;
using MediatR;
using Microsoft.Extensions.DependencyInjection;

// Setup DI / Mediatr
var serviceProvider = new ServiceCollection()
    .AddMediatR(typeof(Program).Assembly)  // This line registers all dependencies of the following types:
                                           // - `IRequestPreprocessor<TRequest, TResponse>`
                                           // - `IRequestHandler<TRequest, TResponse>`
                                           // - `IRequestExceptionHandler<TRequest, TResponse, TException>`
                                           // - `IRequestExceptionAction<TRequest, TException>`
                                           // - `IRequestPostProcessor<TRequest, TResponse>`
                                           // - `INotificationHandler<TNotification>`
    .AddSingleton<ILogStore>(new InMemoryLogStore())
    .AddValidatorsFromAssemblyContaining<Program>()
    // Remember: The order of generic registrations is different: FIFO rather than LIFO!
    .AddTransient(typeof(IPipelineBehavior<,>), typeof(ValidationBehavior<,>))
    .BuildServiceProvider();


// main
var mediator = serviceProvider.GetRequiredService<IMediator>();

// --------------------------- Command ---------------------------------
Console.WriteLine();
Console.WriteLine("Storing test log entries...");
for (byte i = 10; i > 0; i--)
{
    var logMessage = new LogMessage(
        Time: DateTimeOffset.Now,
        Severity: nameof(LogSeverity.Information),
        Message: $"Autogenerated log message {i}"
    );
    
    var id = await mediator.Send(new LogMessageCommand(logMessage));
    Console.WriteLine("     MessageId {0}: \"{1}\"", id, logMessage);
}

// ------------------------------ Query ---------------------------------
Console.WriteLine();
Console.WriteLine("Retrieving list of logs...");
var logs = await mediator.Send(new GetLogsQuery());
foreach (var log in logs)
{
    Console.WriteLine("    {0}", log);
}

return 0;